package Lesson8

import akka.actor.{Actor, ActorSystem, Props}

object Actors extends App {
  case class Greetings(who: String)

  class SimplestActor extends Actor {
    def receive = {
      case Greetings(who) => println(s"Hello $who, pleased to meet you")
    }
  }

  val system = ActorSystem("MySystem")
  val simple_greeter = system.actorOf(Props[SimplestActor])

  simple_greeter ! Greetings("Dr Who")
}

