package Lesson8

import scala.concurrent.Future
import scala.util.{Failure, Success}

object Futures extends App {
  implicit val ec: scala.concurrent.ExecutionContext = scala.concurrent.ExecutionContext.global

  val f: Future[Int] = Future {
    Thread.sleep(650)
    3 + 4
  }

  f onComplete {
    case Success(x: Int) => println(s"Computing done, result is $x")
    case Failure(ex) => println("Error")
  }
}
